#include <iostream>
#include <fstream>

#include <iomanip>
#include <vector>
#include <set>
#include <iterator>
using namespace std;

#define FIN "graf.in"
#define FOUT "graf.out"
#define _INF 10000

typedef vector<int> VI;
typedef VI::iterator IT;
typedef vector<bool> VB;

VI d;
VB sel, inq;
vector<VI> c;       // dupa caz, pt grafuri dense (multe muchi) e avantajos un vector<list<int> > c;
vector<VI>::iterator i, final;
int n, m, S;
int L;

struct Functor {
	
	bool operator () (int i, int j)
	{
		return d[i] < d[j];
	}
};

multiset<int, Functor> Q;

void Read();
void Write();
void Dijkstra();

ofstream fout(FOUT);

int main()
{
	Read();
	Dijkstra();
	Write();
	return 0;
}

void Dijkstra()
{
	d.assign(n + 1, _INF);
	d[S] = 0;
	Q.insert(S);
	inq[S] = true;
	int k;
	while ( !Q.empty() )
	{
		k = *Q.begin();
		Q.erase(Q.begin());   // sterge numai primul element, chiar daca urmatorul are aceeasi valoare pt d[]
		inq[k] = false;
		for (int i = 1; i <= n; ++i)
			if (d[i] > d[k] + c[k][i] )
			{			
				if ( inq[i] ) 
					Q.erase(i);
				else 
					inq[i] = true;
			
				d[i] = d[k] + c[k][i];
				Q.insert(i);
			}
	}
}

void Read()
{
	ifstream fin(FIN);
	fin >> n >> m >> S >> L;
	d.resize(n + 1), 
	c.resize(n + 1);
	inq.resize(n + 1);
	for ( int i = 0; i <= n; i++ )
		c[i].resize(n + 1);
	
	for ( int i = 0; i <= n; i++ )
		c[i].assign(n  + 1, _INF);
	
	int x, y, cost;
	for ( int i = 0; i < m; ++i)
	{
		fin >> x >> y >> cost;

		c[x][y] = c[y][x] = cost;
	}
	
	for ( int i = 0; i <= n; i++ )
		c[i][i] = 0;
} 

void Write()
{
	for ( int i = 1; i <= n; i++ )
 		fout << d[i] << " ";

	
	fout.close();
}
