#include <iostream>
#include <fstream>

#include <iomanip>
#include <vector>
#include <queue>
#include <iterator>
using namespace std;

#define FIN "excursie.in"
#define FOUT "excursie.out"
#define _INF 100000

typedef vector<int> VI;
typedef VI::iterator IT;
typedef vector<bool> VB;

VI d;
VB sel, inq;
vector<VI> c;       // dupa caz, pt grafuri dense (multe muchi) e avantajos un vector<list<int> > c;
vector<VI>::iterator i, final;
int n, m, S;
int L;

struct Comp {
	bool operator () (int i, int j)
	{
		return d[i] < d[j];
	}
};

priority_queue<int, vector<int>, Comp> Q;

void Read();
void Write();
void Dijkstra();

ofstream fout(FOUT);

int main()
{
	Read();
	Dijkstra();
	Write();
	return 0;
}

void Dijkstra()
{
	d.assign(n + 1, _INF);
	d[S] = 0;
	Q.push(S);
	int k;
	while ( !Q.empty() )
	{
		k = Q.top();
		Q.pop();   // sterge numai primul element, chiar daca urmatorul are aceeasi valoare pt d[]
		for (int i = 1; i <= n; ++i)
			if (d[i] > d[k] + c[k][i] )
			{
				d[i] = d[k] + c[k][i];
				Q.push(i);
			}
	}
}

void Read()
{
	ifstream fin(FIN);
	fin >> n >> m >> S >> L;
	d.resize(n + 1), 
	c.resize(n + 1);
	inq.resize(n + 1);
	for ( int i = 0; i <= n; i++ )
		c[i].resize(n + 1);
	
	for ( int i = 0; i <= n; i++ )
		c[i].assign(n  + 1, _INF);
	
	int x, y, cost;
	for ( int i = 0; i < m; ++i)
	{
		fin >> x >> y >> cost;
		c[x][y] = c[y][x] = cost;
	}
	
	for ( int i = 0; i <= n; i++ )
		c[i][i] = 0;
} 

void Write()
{
	// evident ca se putea afisa si altfel
 	int ok = 0;
 	int first = 1;
	for ( int i = 1; i <= n; i++ )
		if ( d[i] <= L && i != S )
			if ( first)
			{
 				fout << i;
 				ok = 1; first = 0;
			}
			else
			{
 				fout << ' ' << i;
 				ok = 1;
			}

	if ( !ok )
		fout << "No solution";
 	fout << '\n';

	
	fout.close();
}
