#include <iostream>
#include <vector>
using namespace std;

typedef vector<int> VI;
typedef VI::iterator IT;

void Afiseaza(VI v)
{
	for ( IT it = v.begin(); it != v.end(); ++it )
		cout << *it << " ";
	cout << '\n';
}

int main()
{
	VI v;
	v.reserve(8);  // capacitate 8 (evita realocarea)

	for (int i = 1; i <= 8; i++ )
		v.push_back(i);   // v = [1, 2, 3, 4, 5, 6, 7, 8]
	Afiseaza(v);          // 1 2 3 4 5 6 7 8

 	IT it1(v.begin() + 2);
	cout << *it1 << '\n';            // afiseaza 3

 	IT it = v.erase(v.begin() + 1);  // sterge 2
 	cout << *it << '\n';             // afiseaza 3 (urmatorul dupa cel sters)

 	// it1 - invalidat (comportament nedefinit) indica in cel 
 	// mai bun caz, pozitia urmatorului dupa cel sters
  	cout << *it1 << '\n'; 
			              
	Afiseaza(v);          // 1 3 4 5 6 7 8

	system("pause");
	return 0;
}

