/*
// Functii:
//
//    make_heap : Converteste o secventa intr-un heap.
//    sort_heap : Sorteaza un heap.
//    push_heap : Insereaza un element intr-un  heap.
//    pop_heap  : Inlatura primul element din heap.
*/

#include <iostream>
#include <algorithm>
#include <functional>
#include <vector>

using namespace std;


int main()
{
   const int VECTOR_SIZE = 8 ;
   typedef vector<int > IntVector ;  // defineste tipul vector<int>

   //Defineste un iterator pentru o clasa vector<int>
   typedef IntVector::iterator IntVectorIt ;

   IntVector H(VECTOR_SIZE) ;
   IntVectorIt it ;

   // Initializare
   H[0] = 4 ;
   H[1] = 10;
   H[2] = 70 ;
   H[3] = 10 ;
   H[4] = 30 ;
   H[5] = 69 ;
   H[6] = 96 ;
   H[7] = 100;

   cout << "H { " ;
   for(it = H.begin(); it != H.end(); it++)
      cout << *it << " " ;
   cout << " }\n" << endl ;

   // converteste H intr-un heap
   make_heap(H.begin(), H.end(), greater<int>()) ;
   cout << "dupa apelul make_heap\n" << endl ;

   cout << "H { " ;
   for(it = H.begin(); it != H.end(); it++)
      cout << *it << " " ;
   cout << " }\n" << endl ;

   // sort the heapified sequence H
   sort_heap(H.begin(), H.end(), greater<int>()) ;
   cout << "After calling sort_heap\n" << endl ;


   cout << "H { " ;
   for(it = H.begin(); it != H.end(); it++)
      cout << *it << " " ;
   cout << " }\n" << endl ;

   make_heap(H.begin(), H.end(), greater<int>()) ;
   //insereaza un element in heap
   H.push_back(7) ;
   push_heap(H.begin(), H.end(), greater<int>()) ;
   cout << "Dupa apelul push_heap()\n" << endl;

    
   cout << "H { " ;
   for(it = H.begin(); it != H.end(); it++)
      cout << *it << " " ;
   cout << " }\n" << endl ;

   // sterge elementul radacina din heap
   pop_heap(H.begin(), H.end(), greater<int>()) ;
   cout << "Dupa apelul pop_heap\n" << endl ;

  
   cout << "H { " ;
   for(it = H.begin(); it != H.end(); it++)
      cout << *it << " " ;
   cout << " }\n" << endl ;
}

