
#include <iostream>
using namespace std;

// "The Big Three Rule" 
// "Daca trebuie sa supraincarci una din urmatoarele functii : destrucor, constructor de copie sau 
// operator de atribuire, aunci trebuie sa le supraincarci pe toate trei"
// Clasele care tin pointeri care indica spre locatii alocate dinamic
// trebuie sa supraincarce cele 3 functii membre speciale
class Big {
    int n;
    int* p;
public:
    Big() :n(0), p(new int[1]) {}
    Big(int i) : n(i), p(new int [n])
    {
        memset(p, 0, sizeof(int)* n);
    }
    Big(const Big& ob);
    Big& operator= (const Big& ob);
   ~Big() { delete[] p; }
  	friend istream& operator>> (istream& is, Big& ob);
   	friend ostream& operator<< (ostream& os, const Big& ob);
};

Big::Big(const Big& ob)
{
    n = ob.n;
    p = new int[n];
    memset(p, 0, sizeof(int)*n);
}

Big& Big::operator= (const Big& ob)
{
	if ( this == &ob)  // autoatribuire
		return *this;

    delete [] p;
    n = ob.n;
    p = new int[n];
    for ( int i = 0; i < n; i++ )
    	p[i] = ob.p[i];
    return *this;
}

istream& operator>> (istream& is, Big& ob)
{
    char a[100000];
    is >> a;
    int n = strlen(a);
    ob.n = n;
    for (int i = 0; i < n; i++ )
    	ob.p[ob.n-1-i] = a[i] - '0';
    return is;
}

ostream& operator<< (ostream& os, const Big& ob)
{
	for ( int i = ob.n - 1; i >=  0; i-- )
		os << ob.p[i];
    return os;
}

int main()
{
    Big x;
	cin >> x;   // operator(cin, x);
	cout << x;
	
	system("pause");
    return 0;
}

