#include <iostream>
using namespace std;

template <typename T, int n>  // n parametru "NON TIP" sau "EXPRESIE"
class Sir {
	T s[n];
public:
	Sir();
	Sir(const T &);
	T& operator [] (int i);
	const T& operator [] (int i) const;
};

template <typename T, int n>
Sir<T, n>::Sir()
{
    for ( int i = 0; i < n; i++ )
        s[i] = 0;
}

template <typename T, int n>
Sir<T, n>::Sir(const T& v)
{
    for ( int i = 0; i < n; i++ )
        s[i] = v;
}

template <typename T, int n>
T& Sir<T, n>::operator [] (int i)
{
    if ( i < 0 || i >= n )
    {
        cerr << "Eroare la limitele tabloului\n";
        exit(1);
    }
    return s[i];
}

template <typename T, int n>
const T& Sir<T, n>::operator [] (int i) const
{
    if ( i < 0 || i >= n )
    {
        cerr << "Eroare la limitele tabloului\n";
        exit(1);
    }
    return s[i];
}



int main()
{
    Sir<double, 12> a;
    for (int i = 0; i < 12; i++ )
        a[i] = i + 1;

    for (int i = 0; i < 12; i++ )
        cout << a[i] << " ";

/*  int nr;
    cin >> nr;
    Sir<float, nr> b;  // non-const nu p fi folosit ca argument template
*/

    Sir<int, 10> *p = new Sir<int, 10>[100];   // care dintre instantierile de mai jos sunt ilegale ?
    delete [] p;

    typedef Sir<char, 20> TC;
    TC *q = new TC[50];

    delete [] q;

    TC c[] = { TC(3), TC('U') };  // ? ? ? ?

	return 0;
}


