#include <stdio.h>
#include <string.h>

#define MAXN 1024
#define MIN(a,b) ((a) < (b) ? (a) : (b))
#define MAX(a,b) ((a) > (b) ? (a) : (b))
#define INF 10100

const int dx[] = {0, 1, 0, -1};
const int dy[] = {1, 0, -1, 0};


int N, K, inc, sf, res;
char viz[MAXN][MAXN], ok[MAXN][MAXN];
int Q[MAXN*MAXN], D[MAXN][MAXN];

int valid(int x, int y)
{
    if(x < 0 || y < 0 || x >= N || y >= N)
        return 0;
    return 1;
}

void bfs(void)
{
    int i, k, nx, ny, x, y;

    while(inc <= sf)
    {
        x = Q[inc]>>10, y = Q[inc++]&1023;
        for(k = 0; k < 4; k++)
         if(valid(nx = x+dx[k], ny = y+dy[k]) && !viz[nx][ny])
         {
            viz[nx][ny] = 1, D[nx][ny] = D[x][y]+1;
            Q[++sf] = (nx<<10)+ny;
         }
    }
}

void o_lumina_si_nu_stiu(void)
{
    int i, j, x, y, best;

    res = INF;
    
    for(x = 0; x < N; x++)
     for(y = 0; y < N; y++)
      if(!ok[x][y])
      {

        memset(viz, 0, sizeof(viz));

        inc = 0, sf = -1;

        for(i = 0; i < N; i++)
         for(j = 0; j < N; j++)
          if(ok[i][j])
            viz[i][j] = 1, Q[++sf] = (i<<10)+j, D[i][j] = 0;

        Q[++sf] = (x<<10)+y;
        viz[x][y] = 1, D[x][y] = 0;
        bfs();
        
        for(best = -INF, i = 0; i < N; i++)
         for(j = 0; j < N; j++)
            best = MAX(best, D[i][j]);

        res = MIN(res, best);
      }

    i++, i--;
}

void vad_la_fereastra_ta_tarziu(void)
{
    int i, j, x, y;
    
    scanf("%d %d\n", &N, &K);

    for(i = 0; i < K; i++)
        scanf("%d %d\n", &x, &y), ok[x][y] = 1;
}

void de_esti_treaza_ori_visezi(void)
{
    printf("%d\n", res);
}

int main(void)
{
    freopen("centru.in", "rt", stdin);
    freopen("centru.out", "wt", stdout);

    vad_la_fereastra_ta_tarziu();
    o_lumina_si_nu_stiu();
    de_esti_treaza_ori_visezi();

    return 0;
}




            



































    
    

    

