#include <cstdio>
#include <algorithm>
#include <cstring>
#include <math.h>
#include <cstdlib>

using namespace std;

#define x first
#define y second
#define mp make_pair

#define Nmax 1024

const int dx[] = {-1, 0, 1, 0};
const int dy[] = {0, 1, 0, -1};

int n, m;
int a[Nmax][Nmax];
pair<int, int> v[Nmax*Nmax];

pair<int, int> Q[Nmax*Nmax];
int cont, cap;

char viz[Nmax][Nmax];

void readdata()
{
    freopen("centru.in", "r", stdin);
    freopen("centru.out", "w", stdout);

    scanf("%d %d", &n, &m);
    for (int i = 1; i <= m; ++i)
        scanf("%d %d", &v[i].x, &v[i].y);
}

int posibil(int m)
{
    int i, j;
    int minim, maxim;
    int ii, jj;

    memset(viz, 0, sizeof(viz));
    
    for (i = 0; i < n; ++i)
    for (j = 0; j < n; ++j)
        if (abs(i - v[ a[i][j] ].x) + abs(j - v[ a[i][j] ].y) <= m)
            viz[i][j] = 1;

    minim = maxim = 0;
    for (i = 0; i <= n*2-2; ++i)
    {
        if (i <= n-1)
        {
            ii = 0;
            jj = i;
        }
        else
        {
            ii = i - (n-1);
            jj = n-1;
        }
        
        while ( ii < n && jj >= 0 )
        {
            if (!viz[ii][jj])
            {
                if (!minim) minim = i;
                maxim = i;
            }
            ++ii; --jj;
        }
    }
    if (maxim - minim > 2*m) return 0;

    minim = maxim = 0;
    for (i = 0; i <= n*2-2; ++i)
    {
        if (i <= n-1)
        {
            jj = 0;
            ii = n-1-i;
        }
        else
        {
            ii = 0;
            jj = i - (n-1);
        }
        while (ii < n && jj < n)
        {
            if (!viz[ii][jj])
            {
                if (!minim) minim = i;
                maxim = i;
            }
            ++ii; ++jj;
        }
    }
    if (maxim - minim > 2*m) return 0;
    
    return 1;
}

int search(int st, int dr)
{
    int m;

    while (st != dr)
    {
        m = (st+dr)/2;
        if (posibil(m)) dr = m;
        else st = m+1;
    }
    return st;
}

void solve()
{
    int i, j;
    int ii, jj;

    for (i = 1; i <= m; ++i)
    {
        a[ v[i].x ][ v[i].y ] = i;
        Q[++cont] = v[i];
    }
    
    cap = 1;
    while (cap <= cont)
    {
       for (i = 0; i < 4; ++i)
       {
          ii = Q[cap].x + dx[i];
          jj = Q[cap].y + dy[i];

          if (ii >= 0 && ii < n && jj >= 0 && jj < n)
          if (!a[ii][jj])
          {
              a[ii][jj] = a[ Q[cap].x ][ Q[cap].y ];
              Q[++cont] = mp(ii, jj);
          }
       }
       ++cap;
    }

    printf("%d\n", search(0, n));
}

int main()
{
    readdata();
    solve();
    return 0;
}
