#include <stdio.h>

#define nm 1024
#define km 1048576

const int dx[4] = {0, -1, 0, 1};
const int dy[4] = {-1, 0, 1, 0};

int n, k, x[km], y[km], sol[nm][nm], a[nm][nm], qx[km], qy[km], st, dr;

int solve()
{
	int i, j, d, max = 0;

	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j)
			a[i][j] = -1;

	st = dr = 0;

	for (i = 1; i <= k; ++i)
	{
		a[x[i]][y[i]] = 0;
		qx[dr] = x[i];
		qy[dr] = y[i];
		++dr;
	}
		
	while (st < dr)
	{
		for (d = 0; d < 4; ++d)
			if (qx[st] + dx[d] >= 0 && qx[st] + dx[d] < n && qy[st] + dy[d] >= 0 && qy[st] + dy[d] < n && a[qx[st] + dx[d]][qy[st] + dy[d]] == -1)
			{
				qx[dr] = qx[st] + dx[d];
				qy[dr] = qy[st] + dy[d];
				a[qx[dr]][qy[dr]] = a[qx[st]][qy[st]] + 1;
				
				if (a[qx[dr]][qy[dr]] > max)
					max = a[qx[dr]][qy[dr]];
					
				++dr;
			}
		++st;
	}

	return max;
}

int main()
{
	int i, j, max = -1, sx, sy, nr;

	freopen("centru.in", "r", stdin);
	freopen("centru.out", "w", stdout);

	scanf("%d%d", &n, &k);

	for (i = 1; i <= k; ++i)
		scanf("%d%d", &x[i], &y[i]);

	solve();

	for (i = 0; i < n; ++i)
		for (j = 0; j < n; ++j)
			if (max < a[i][j])
			{
				max = a[i][j];
				sx = i;
				sy = j;
				nr = 1;
			}
			else if (max == a[i][j])
			{
				sx += i;
				sy += j;
				++nr;
			}

	x[++k] = sx / nr;
	y[k] = sy / nr;
	
	printf("%d\n", solve());
	
	return 0;
}
