#include <stdio.h>

const char iname[] = "centru.in";
const char oname[] = "centru.out";

#define MAXN  1000
#define INF   int(1e7)

int  N, K;

bool A[MAXN][MAXN], B[MAXN][MAXN];

int  D[MAXN][MAXN], E[MAXN][MAXN];

int  Q[MAXN * MAXN];

int  L[MAXN * MAXN][2], cnt;

int  dx[] = {-1, 0, +1, 0}, dy[] = {0, +1, 0, -1};


void read_in(void)
{
    int x;
    int y;

    scanf("%d %d", &N, &K);
    for (int i = 0; i < K; ++ i) {
       scanf("%d %d", &x, &y);
       A[x][y] = B[x][y] = true;
    }
}

inline bool onboard(const int x, const int y) {
    return (x >= 0 && y >= 0 && x < N && y < N);
}

inline int modul(const int a) {
    if (a < 0)   return (-a);
    return a;
}

void BF(bool B[][MAXN], int D[][MAXN])
{
    int i;
    int j;
    int k;
    int x, y;
    int head = 0, tail = 0;

    for (i = 0; i < N; ++ i)
       for (int j = 0; j < N; ++ j) {
          if (B[i][j] == true)
             Q[tail ++] = i * N + j, D[i][j] = 0;
          else
             D[i][j] = INF;
       }
    for (; head < tail; ++ head) {
       i = Q[head] / N;
       j = Q[head] % N;
       for (k = 0; k < 4; ++ k) {
           x = i + dx[k], y = j + dy[k];
           if (onboard(x, y) == false)
               continue ;
           if (D[x][y] > D[i][j] + 1)
               D[x][y] = D[i][j] + 1, Q[tail ++] = x * N + y;
       }
    }
}

void print(int A[][MAXN]) {
    for (int i = 0; i < N; ++ i, printf("\n"))
        for (int j = 0; j < N; ++ j)
            printf("%d ", A[i][j]);
//  printf("\n");
}

int solve(const int K)
{
    int i;
    int j;
    int k;
    int stp;
    int x, y;
    int head = 0, tail = 0;

    cnt = 0;
    for (i = 0; i < N; ++ i)
        for (j = 0; j < N; ++ j) {
            if (D[i][j] > K) {
                E[i][j] = 0, Q[tail ++] = i * N + j;
                L[cnt][0] = i, L[cnt][1] = j, cnt ++;
            } else
                E[i][j] = INF;
        }
    for (; head < tail; ++ head) {
        i = Q[head] / N;
        j = Q[head] % N;
        int t;
        for (t = 0; t < cnt; ++ t)
            if (modul(i - L[t][0]) + modul(j - L[t][1]) > K)
               break ;
        if (t == cnt)
              return 1;
        if (E[i][j] == K)   continue ;

        for (k = 0; k < 4; ++ k) {
           x = i + dx[k], y = j + dy[k];
           if (onboard(x, y) == false)
               continue ;
           if (E[x][y] > E[i][j] + 1)
               E[x][y] = E[i][j] + 1, Q[tail ++] = x * N + y;
        }
    }
    return 0;
}

int main(void)
{
    freopen(iname, "r", stdin);
    freopen(oname, "w", stdout);
    read_in();

    BF(B, D);
    int max = 0;
    int stp;
    int i;
    int j;
    for (i = 0; i < N; ++ i)
       for (j = 0; j < N; ++ j)
          if (max < D[i][j])   max = D[i][j];

    /* cautare binara cu k dupa max */
    for (stp = 1; stp < max; stp <<= 1) ;
    for (i = 0; stp; stp >>= 1) {
       if (i + stp < max && !solve(i + stp))
          i = i + stp;
    }
    if (solve(i) == 0)
        ++ i;
    printf("%d\n", i);

    return 0;
}
