#include <stdio.h>

#define MAXN  100005
#define MAXT  262144
#define MAXLG 31

char T[MAXLG][MAXT];

int  d[MAXN];

int  N, M;

int  cnt[MAXLG];


void insert_tree(char T[], int n, int lo, int hi, int p, char tf)
{
    int mid = (hi + lo) >> 1;
    if (hi == lo) {
       T[n] = tf;   return ;
    }
    if (p <= mid)
       insert_tree(T, 2 * n, lo, mid, p, tf);
    else
       insert_tree(T, 2 * n + 1, mid + 1, hi, p, tf);

    T[n] = T[2 * n] || T[2 * n + 1];
}

int query_tree(char T[], int n, int lo, int hi)
{
    int mid = (hi + lo) >> 1;
    if (hi == lo)
       return hi;

    if (T[2 * n])
       return query_tree(T, 2 * n, lo, mid);
    return query_tree(T, 2 * n + 1, mid + 1, hi);
}

void count(const int val, const int n)
{
    int i;
    for (i = 0; i < 31; ++ i)
        if ((val >> i) & 1)   cnt[i] += n;
}

void insert(int i, char tf)
{
    if (d[i] == 0)  return ;

    count(d[i], tf ? +1 : -1);

    int bit;

    for (bit = 30; bit >= 0; -- bit)
       if ((d[i] >> bit) & 1)
          break ;
    insert_tree(T[bit], 1, 1, N, i, tf);
}

int nimsum(void)
{
    int sum = 0;
    int i;

    for (i = 0; i < 31; ++ i)
       if (cnt[i] & 1)  sum |= 1 << i;
    return sum;
}

int main(void)
{
    int l, r, i, j;
    int sum;

    scanf("%d %d", &N, &M);

    for (i = 1; i <= N; ++ i) {
       scanf("%d %d", &l, &r);
       d[i] = r-l-1;
       insert(i, +1);
    }

    for (sum = nimsum(); sum > 0; sum = nimsum()) {
       /* mutarea mea */
       int bit;
       for (bit = 30; bit >= 0; -- bit)
          if ((sum >> bit) & 1)
             break ;
       i = query_tree(T[bit], 1, 1, N);
       printf("%d %d\n", i, d[i] - (sum ^ d[i]));
       fflush(stdout);

       insert(i, 0), d[i] = sum ^ d[i], insert(i, +1);

       char continua = 0;
       for (i = 0; i < MAXLG; ++ i)  continua = continua || T[i][1];
       if (continua == 0)
          break ;

       /* mutarea adversarului */
       scanf("%d %d", &i, &j);
       insert(i, 0), d[i] -= j, insert(i, +1);
    }

    return 0;
}
