#include <cstdio>
#include <queue>

using namespace std;

const int MAXN = 1024;
const int MAXD = 2048;
const int INF = 0x3f3f3f3f;

int N, K;
int d[MAXN][MAXN];

queue< pair<int, int> > Q;

const int dx[4] = {-1, 0, 1, 0};
const int dy[4] = {0, 1, 0, -1};

int yMin[MAXN], yMax[MAXN];

int pos( int L )
{
	for (int i = 0; i < N; i++)
	{
		yMin[i] = INF;
		yMax[i] = -INF;
		
		for (int j = 0; j < N; j++)
			if (d[i][j] > L)
			{
				if (j < yMin[i])
					yMin[i] = j;
				if (j > yMax[i])
					yMax[i] = j;
			}
	}
	
	for (int x = 0; x < N; x++)
	{
		int l = 0, r = N - 1;
		for (int i = 0; i < N && l <= r; i++)
		{
			if (yMin[i] == INF || yMax[i] == -INF)
				continue;
	
			int V, ABS = abs(x - i);
			// |y - ymax[i]| <= L - |x - i|
			
				// y <= L - |x - i| + ymax[i]
			V = L - ABS + yMax[i];
			if (V < r) r = V;
			
				// y >= ymax[i] - L + |x - i|
			V = yMax[i] - L + ABS;
			if (V > l) l = V;
			
			// |y - ymin[i]| <= L - |x - i|
			V = L - ABS + yMin[i];
			if (V < r) r = V;
			
			V = yMin[i] - L + ABS;
			if (V > l) l = V;
		}
		
		if (l <= r)
			return 1;
	}
	return 0;
}

int main()
{
	freopen("centru.in", "rt", stdin);
	freopen("centru.out", "wt", stdout);

	scanf("%d %d", &N, &K);
	memset(d, -1, sizeof(d));
	for (int i = 0; i < K; i++)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		d[a][b] = 0;
		Q.push( make_pair(a, b) );
	}

	for (; !Q.empty(); Q.pop())
	{
		int a, b;
		a = Q.front().first;
		b = Q.front().second;
		for (int k = 0; k < 4; k++)
		{
			int _a, _b;
			_a = a + dx[k];
			_b = b + dy[k];
	
			if (_a < 0 || _b < 0 || _a >= N || _b >= N)
				continue;
		
			if (d[_a][_b] != -1)
				continue;
			d[_a][_b] = d[a][b] + 1;
			Q.push( make_pair(_a, _b) );
		}
	}

	int sol, step;
	for (sol = 0, step = MAXD; step; step >>= 1)
		if (!pos( sol + step ))
			sol += step;
	
	printf("%d\n", sol + 1);

	return 0;
}
