#include <cstdio>
#include <set>

using namespace std;

const int MAXN = 100005;
const int NRB = 31;

int N, M;
int x[MAXN], XOR, left;
set< pair<int, int>, greater< pair<int, int> > > S;

int GSB( int N )
{
	int rez, step;
	for (rez = 0, step = 16; step; step >>= 1)
		if ((rez + step < NRB) && ((1 << (rez + step)) <= N))
			rez += step;
	return rez;
}

inline void TAKE( int k, int v )
{
	if (v <= 0)
		fprintf(stderr, "BUG TAKE %d %d\n", k, v);

	//set erasing is taken care of
	XOR ^= x[k];
	x[k] -= v;
	if (x[k])
		XOR ^= x[k],
		S.insert( make_pair( x[k], k ) );
	else
		left--;
	
	printf("%d %d\n", k, v);
	fflush( stdout );
}

inline void READMOVE()
{
	if (XOR != 0)
		fprintf(stderr, "BUG READMOVE\n");

	int a, b;
	scanf("%d %d", &a, &b);
	
	S.erase( make_pair( x[a], a ) );
	XOR ^= x[a];
	x[a] -= b;
	if (x[a])
		XOR ^= x[a],
		S.insert( make_pair( x[a], a ) );
	else
		left--;
}

int main()
{
	scanf("%d %d", &N, &M);
	XOR = 0;
	for (int i = 1; i <= N; i++)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		x[i] = b - a - 1;
			
		XOR ^= x[i];
		left += (x[i] > 0);

		S.insert( make_pair(x[i], i) );
	}
	
	for (; left; )
	{
		set< pair<int, int> > :: iterator it;

		for (it = S.begin(); it != S.end(); it++)
			if ((*it).first > (XOR ^ (*it).first))
			{
				TAKE( (*it).second, (*it).first - (XOR ^ (*it).first) );
				S.erase( it );
				break;
			}
		if (left)
			READMOVE();
	}
	
	return 0;
}
