#include <cstdio>
#include <set>
#include <vector>

using namespace std;

long long N;
int T0, T1, a, b, x, y, z, MOD;

int m[3][3], r[3][3];
set< pair<int, int> > S;
vector<int> P;

inline void mul( int a[3][3], int b[3][3] )
{
	int c[3][3];
	memset(c, 0, sizeof(c));
	for (int i = 0; i < 3; i++)
		for (int j = 0; j < 3; j++)
			for (int k = 0; k < 3; k++)
				c[i][j] += (a[i][k] * b[k][j]) % MOD,
				c[i][j] %= MOD;
	memcpy(a, c, sizeof(c));
}

void pow( long long N )
{
	if (N == 1)
	{
		memcpy(r, m, sizeof(m));
		return;
	}

	if (N % 2 == 0)
		pow( N >> 1 ),
		mul(r, r);
	else
		pow( N - 1 ),
		mul(r, m);
}

inline int getNew( int T0, int T1 )
{
	int rez = ((T0 * T0) % MOD * a) % MOD;
	rez += ((T1 * T1) % MOD * b) % MOD;
	rez += (T0 * x + T1 * y + z) % MOD;
	return rez % MOD;
}

int main()
{
	freopen("sir.in", "rt", stdin);
	freopen("sir.out", "wt", stdout);
	scanf("%d %d %d %d %d %d %d %d %lld", &T0, &T1, &a, &b, &x, &y, &z, &MOD, &N);

	T0 %= MOD; T1 %= MOD;
	a %= MOD; b %= MOD; x %= MOD; y %= MOD; z %= MOD;

	if (N == 0)
	{
		printf("%d\n", T0);
		return 0;
	}
	if (N == 1)
	{
		printf("%d\n", T1);
		return 0;
	}

	if (a == 0 && b == 0)
	{
		m[0][0] = m[0][2] = m[1][2] = m[2][0] = 0;
		m[0][1] = x; m[1][1] = y; m[2][1] = z;
		m[1][0] = m[2][2] = 1;
	
		pow(N - 1);
	
		printf("%d\n", (T0 * r[0][1] + T1 * r[1][1] + r[2][1]) % MOD);
		return 0;
	}

	P.push_back( T0 );
	P.push_back( T1 );
	S.insert( make_pair(T0, T1) );

	for (long long i = 2; i <= N; i++)
	{
		int New = getNew( P[ P.size() - 2 ], P.back() ), Old = P.back();

		if (S.find( make_pair( Old, New ) ) != S.end())
		{
			int nr = 1; size_t p;
			for (p = P.size() - 1; P[p] != New || P[p - 1] != Old; p--)
				nr++;

			N -= p - 1;
			N %= nr;
			printf("%d\n", P[p + N - 1]);
			return 0;
		}
		else
		{
			P.push_back( New );
			S.insert( make_pair( Old, New ) );
		}	
	}
	printf("%d\n", P.back());
		
	return 0;
}
