#include <stdio.h>
#include <string.h>

#define maxim(a, b) ((a > b) ? a : b)
#define minim(a, b) ((a < b) ? a : b)
#define INF 900000000
#define NMax 1005

int N, K, D[NMax][NMax], C[NMax][NMax], A[2048], bst;

int modul(int X)
{ if (X < 0) return -X; return X; }

void update(int nod, int l, int r, int poz, int val)
{
    int m;

    if (l == r)
        A[nod] = minim(A[nod], val);
    else
    {
        m = (l + r) / 2;
        if (poz <= m) update(2*nod, l, m, poz, val);
        else update(2*nod+1, m+1, r, poz, val);

        A[nod] = minim(A[2*nod], A[2*nod+1]);
    }
    
}

int query(int nod, int l, int r, int a, int b)
{
    int m, i1, i2;

    if (a <= l && r <= b)
        return A[nod];
    else
    {
        m = (l + r) / 2;
        i1 = i2 = INF;
        if (a <= m) i1 = query(2*nod, l, m, a, b);
        if (b > m) i2 = query(2*nod+1, m+1, r, a, b);

        return minim(i1, i2);
    }
    
}

void caz1(void) // cadran I
{
    int i, j, r;
    
    for (i = 0; i < 2048; i++) A[i] = INF;

    for (i = N-1; i >= 0; i--)
    {
        for (j = 0; j < N; j++)
            if (D[i][j])
                update(1, 0, N-1, j, i + j);
        for (j = 0; j < N; j++)
        {
            r = query(1, 0, N-1, j, N-1);
            C[i][j] = minim(C[i][j], r - i - j);
        }
        
    }

}

void caz2(void) // cadran II
{
    int i, j, r;
    
    for (i = 0; i < 2048; i++) A[i] = INF;

    for (i = N-1; i >= 0; i--)
    {
        for (j = 0; j < N; j++)
            if (D[i][j])
                update(1, 0, N-1, j, i - j);
        for (j = 0; j < N; j++)
        {
            r = query(1, 0, N-1, 0, j);
            C[i][j] = minim(C[i][j], j - i + r);
        }
        
    }

}

void caz3(void) // cadran III
{
    int i, j, r;
    
    for (i = 0; i < 2048; i++) A[i] = INF;

    for (i = 0; i < N; i++)
    {
        for (j = 0; j < N; j++)
            if (D[i][j])
                update(1, 0, N-1, j, - i - j);
        for (j = 0; j < N; j++)
        {
            r = query(1, 0, N-1, 0, j);
            C[i][j] = minim(C[i][j], i + j + r);
        }
        
    }

}

void caz4(void) // cadran IV
{
    int i, j, r;
    
    for (i = 0; i < 2048; i++) A[i] = INF;

    for (i = 0; i < N; i++)
    {
        for (j = 0; j < N; j++)
            if (D[i][j])
                update(1, 0, N-1, j, - i + j);
        for (j = 0; j < N; j++)
        {
            r = query(1, 0, N-1, j, N-1);
            C[i][j] = minim(C[i][j], i - j + r);
        }
        
    }
    
}

int check(int X)
{
    int i, j, r, sx = 0, sy = 0, nr = 0;

    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            if (C[i][j] > X)
                sx += i, sy += j, nr++;

    if (nr == 0 || nr == 1) return 1;
                
    sx /= nr; sy /= nr;

    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            if (C[i][j] > X)
            {
                r = modul(i-sx) + modul(j-sy);
                if (r > X) return 0;
            }
            
    return 1;
}

int main(void)
{
    int i, j, u, v, l, r, m, ok;
    
    freopen("centru.in", "r", stdin);
    freopen("centru.out", "w", stdout);

    scanf("%d %d", &N, &K);
    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            C[i][j] = INF;

    for (; K; K--)
    {
        scanf("%d %d", &u, &v);
        D[u][v] = 1;
    }

    caz1();
    caz2();
    caz3();
    caz4();

    l = 0; r = 2*N;
    while (l <= r)
    {
        m = (l + r) / 2;
        ok = check(m);
        if (ok)
            bst = m, r = m-1;
        else
            l = m+1;
    }
        
    printf("%d\n", bst);
    
    return 0;
}

