#include <cstdio>
#include <cstring>
#include <vector>
#include <queue>

using namespace std;

#define MP make_pair
#define x first
#define y second

typedef pair <int, int> coor;

const int NMAX = 1024;
const int INF = 0x3f3f3f3f;
const int NDIR = 4;
const int tx[] = {-1, 0, 1, 0};
const int ty[] = {0, -1, 0, 1};

int N, K, rez = INF;
int A[NMAX][NMAX];
vector <coor> C;
queue <coor> Q;

void read(void) {
	FILE *fin = fopen("centru.in", "rt");
	int i;

	fscanf(fin, " %d %d", &N, &K);

	C.resize(K + 1);

	for (i = 0; i < K; ++i) 
		fscanf(fin, " %d %d", &C[i].x, &C[i].y);

	fclose(fin);
}

coor get_max() {
	int i, j, mx, cnt = 1;
	coor u, v, t;

	memset(A, 0x3f, sizeof(A));

	for (i = 0; i < K; ++i)
		Q.push(C[i]),
		A[C[i].x][C[i].y] = 0;
	
	for (; !Q.empty(); Q.pop()) {
		u = Q.front();

		for (j = 0; j < NDIR; ++j) {
			v = MP(u.x + tx[j], u.y + ty[j]);

			if (v.x < 0 || v.x >= N || v.y < 0 || 
				v.y >= N || A[u.x][u.y] + 1 >= A[v.x][v.y]) continue;
				
			A[v.x][v.y] = A[u.x][u.y] + 1;
			Q.push(v);
		}
	}

	mx = -1;
	for (i = 0; i < N; ++i) 
		for (j = 0; j < N; ++j) {
			if (mx == A[i][j])
				t.x += i, t.y += j, ++cnt;

			if (mx < A[i][j]) {
				mx = A[i][j];
				t = MP(i, j);
				cnt = 1;
			}
		}

	rez <?= mx;

//	printf("%d %d => %d\n", C[K - 1].x, C[K - 1].y, mx);
	
	return MP(t.x / cnt, t.y / cnt);
}

void solve(void) {

	C[K] = get_max();

	++K;
	
	get_max();
	
	++C[K - 1].x;
	get_max();
	
	++C[K - 1].y;
	get_max();
	
	--C[K - 1].x;
	get_max();
}

void write(void) {
	FILE *fout = fopen("centru.out", "wt");

	fprintf(fout, "%d\n", rez);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}

