#include <cstdio>
#include <cstring>

const int NMAX = 3;

int M;
int A[NMAX][NMAX], rez[NMAX][NMAX], T[NMAX][NMAX];

void mult(int A[NMAX][NMAX], int B[NMAX][NMAX], int C[NMAX][NMAX]) {
	int D[NMAX][NMAX];
	int i, j, k;

	memset(D, 0x00, sizeof(D));

	for (i = 0; i < NMAX; ++i)
		for (j = 0; j < NMAX; ++j)
			for (k = 0; k < NMAX; ++k)
				D[i][j] = (D[i][j] + A[i][k] * B[k][j]) % M;
	
	memcpy(C, D, sizeof(D));
}

int main(void) {
	
	FILE *fin = fopen("sir.in", "rt");
	FILE *fout = fopen("sir.out", "wt");
	int x, y;
	long long n;

	A[0][0] = 1;
	A[1][2] = 1;
	T[0][0] = 1;
	
	fscanf(fin, " %d %d", &T[1][0], &T[2][0]);

	fscanf(fin, " %d %d %d %d %d", &x, &y, &A[2][1], &A[2][2], &A[2][0]);

	fscanf(fin, " %d %lld", &M, &n);

	T[1][0] %= M; T[2][0] %= M;
	rez[0][0] = rez[1][1] = rez[2][2] = 1;

	for (; n; n >>= 1LL) {
		if (n & 1LL)
			mult(A, rez, rez);
		mult(A, A, A);
	}

	mult(rez, T, T);

	fprintf(fout, "%d\n", T[1][0]);

	fclose(fin);
	fclose(fout);
	
	return 0;
}

