#include <stdio.h>
#include <string.h>

#define NMAX 1010

int N, M;

int cx[NMAX * NMAX];
int cy[NMAX * NMAX];

int dist[NMAX][NMAX];
char viz[NMAX][NMAX];

int dx[] = {0, 0, 1,-1};
int dy[] = {1,-1, 0, 0};

int xx[NMAX * NMAX];
int yy[NMAX * NMAX];

int lmin[NMAX];
int lmax[NMAX];

short dst[NMAX][NMAX];
short ddr[NMAX][NMAX];

char exst[NMAX];
char exdr[NMAX];

inline int MIN(int a, int b) { return (a < b) ? a : b; }
inline int MAX(int a, int b) { return (a > b) ? a : b; }
inline int ABS(int x) { return (x < 0) ? -x : x; }

void print_mem()
{
	printf("%lf\n", (double) (sizeof(cx) + sizeof(cy) + sizeof(dist) + sizeof(viz) + sizeof(xx) + sizeof(yy) + sizeof(lmin) + sizeof(lmax) + sizeof(dst) + sizeof(ddr) + sizeof(exst) + sizeof(exdr)) / 1024 / 1024);
}

void make_bf()
{
	int p, q, i, j;

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) dist[i][j] = NMAX * NMAX;

	p = 0; q = -1;
	for (i = 1; i <= M; i++) {
		q++;
		xx[q] = cx[i];
		yy[q] = cy[i];
		dist[xx[q]][yy[q]] = 0;
		viz[xx[q]][yy[q]] = 1;
	}

	int x1, y1, x, y;

	while (p <= q) {
		x = xx[p];
		y = yy[p];
		p++;

		for (i = 0; i < 4; i++) {
			x1 = x + dx[i];
			y1 = y + dy[i];

			if (!(1 <= x1 && x1 <= N && 1 <= y1 && y1 <= N)) continue;
			if (viz[x1][y1]) continue;
			q++;
			xx[q] = x1;
			yy[q] = y1;
			viz[x1][y1] = 1;
			dist[x1][y1] = dist[x][y] + 1;
		}
	}
}
/*
int get_kkt(int x, int y)
{
	int i, j, k, dst, mx = 0;

	for (i = 1; i <= N; i++) 
		for (j = 1; j <= N; j++) {
			dst = N * N;
			for (k = 1; k <= M; k++) {
				dst = MIN(dst, ABS(i - cx[k]) + ABS(j - cy[k]));
			}
			dst = MIN(dst, ABS(i - x) + ABS(j - y));
			mx = MAX(mx, dst);
		}

	return mx;
}

int get_brute()
{
	int i, j, mn = N * N;

	for (i = 1; i <= N; i++)
		for (j = 1; j <= N; j++) {
			mn = MIN(mn, get_kkt(i, j));
		}

	return mn;

}

char ap[NMAX][NMAX];

#include <stdlib.h>
int gen(int N, int M)
{
	freopen("centru.in", "w", stdout);

	int i, x, y;

	printf("%d %d\n", N, M);


	for (i = 1; i <= M; i++) {
		x = rand() % N;
		y = rand() % N;

		if (ap[x][y]) {
			i--;
			continue;
		}

		ap[x][y] = 1;
		printf("%d %d\n", x, y);
	}

fclose(stdout);
return 0;
}
*/

int main()
{
//	print_mem();
	
//	srand(132121);
//	gen(1000, 100);
	
	int i, j;
	
	freopen("centru.in", "r", stdin);
	freopen("centru.out", "w", stdout);

	scanf("%d %d", &N, &M);

	for (i = 1; i <= M; i++) {
		scanf("%d %d", &cx[i], &cy[i]);
		cx[i]++;
		cy[i]++;
	}

	make_bf();

	int step;
	for (step = 1; step <= N + N; step <<= 1);

	int x = 0;

	int dcur;

	int mn;

/*	for (i = 1; i <= N; i++) {
		for (j = 1; j <= N; j++) printf("%d ", dist[i][j]);
		printf("\n");
	}
	printf("\n");
*/
	
	int ss;

	for (; step; step >>= 1) {
		// calc min max 

		dcur = x + step;

		for (i = 1; i <= N; i++) lmin[i] = N + 1, lmax[i] = 0;

		memset(exst, 0, sizeof(exst));
		memset(exdr, 0, sizeof(exdr));

		for (j = 1; j <= N; j++) {
			for (i = 1; i <= N; i++) exst[j] |= dist[i][j] > dcur;
			exst[j] |= exst[j - 1];
		}

		for (j = N; j >= 1; j--) {
			for (i = 1; i <= N; i++) exdr[j] |= dist[i][j] > dcur;
			exdr[j] |= exdr[j + 1];
		}

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++)
				if (dist[i][j] > dcur) {
					lmin[j] = MIN(lmin[j], i);
					lmax[j] = MAX(lmax[j], i);
				}

//		for (i = 1; i <= N; i++) printf("%d %d\n", lmin[i], lmax[i]);
//		printf("\n");

		// calculez dstanga

		for (i = 1; i <= N; i++)
			for (j = 1; j <= N; j++) {
				ss = MAX( (lmin[j] == N + 1) ? 0 : ABS(i - lmin[j]), (lmax[j] == 0) ? 0 : ABS(i - lmax[j]) );

				if (j == 1) dst[i][j] = ss;
				else dst[i][j] = MAX( ss, (exst[j-1]) ? 1 + dst[i][j-1] : 0);
			}

/*		for (i = 1; i <= N; i++) {
			for (j = 1; j <= N; j++) printf("%d ", dst[i][j]);
			printf("\n");
		}
		printf("\n");
*/
		// calculez ddreapta

		for (i = 1; i <= N; i++)
			for (j = N; j >= 1; j--) {
				ss = MAX( (lmin[j] == N + 1) ? 0 : ABS(i - lmin[j]), (lmax[j] == 0) ? 0 : ABS(i - lmax[j]) );

				if (j == N) ddr[i][j] = ss;
				else ddr[i][j] = MAX( ss, (exdr[j+1]) ? 1 + ddr[i][j + 1] : 0);
			}

/*		for (i = 1; i <= N; i++) {
			for (j = 1; j <= N; j++) printf("%d ", ddr[i][j]);
			printf("\n");
		}
		printf("\n");
*/

		mn = N * N;

		for (i = 1; i <= N; i++) {
			for (j = 1; j <= N; j++) {
				mn = MIN( mn, MAX(dst[i][j], ddr[i][j]) );
//				printf("%d ", MAX(dst[i][j], ddr[i][j]));
			}
//			printf("\n");
		}

//		printf("%d %d\n", dcur, mn);

		if (mn > dcur) x += step;
	}

	printf("%d\n", x + 1);

//	printf("%d\n", get_brute());

fclose(stdin);
fclose(stdout);
return 0;
}

