#include <string.h>
#include <stdio.h>

#define MAXN 152

int N, M;
short int res;
short int sum[MAXN][MAXN], Up[MAXN][MAXN][MAXN], Down[MAXN][MAXN][MAXN];
short int Max[2][MAXN][MAXN];
int prev, crt;

short int getsum(int i, int j, int k)
{
    return sum[i][k]-sum[i][j-1]-sum[i-1][k]+sum[i-1][j-1];
}

short int max(short int a, short int b)
{
    return a > b ? a : b;
}

short int baga_up(int i, int j, int k)
{
    int t1 = 0, t2 = 0, t3 = 0;
    
    if(Up[i][j][k] != -1)
        return Up[i][j][k];

    if(j >= 2)
        t1 = baga_up(i, j-1, k);
    if(k <= M-1)
        t2 = baga_up(i, j, k+1);
    t1 = max(t1, t2);
    if( getsum(i, j, k) == 0 )
        Max[crt][j][k] = t3 = k-j+1+Max[prev][j][k];
    t1 = max(t1, t3);
    return Up[i][j][k] = t1;
}

short int baga_down(int i, int j, int k)
{
    int t1 = 0, t2 = 0, t3 = 0;
    
    if(Down[i][j][k] != -1)
        return Down[i][j][k];
        
    if(j >= 2)
        t1 = baga_down(i, j-1, k);
    if(k <= M-1)
        t2 = baga_down(i, j, k+1);
    t1 = max(t1, t2);
    if( getsum(i, j, k) == 0 )
        Max[crt][j][k] = t3 = k-j+1+Max[prev][j][k];
    t1 = max(t1, t3);
    return Down[i][j][k] = t1;
}

void solve_up(void)
{
    int i, j, k, t;

    prev = 0, crt = 1;
    memset(Max, 0, sizeof(Max));
    
    for(i = 1; i <= N; i++)
    {
        // pentru mijloc
        for(j = 2; j < M; j++)
         for(k = j; k < M; k++)
          if( getsum(i, j, k) == 0 )
          {
                t = max(Up[i-1][j-1][k+1], Up[i-1][k][j]);
                if(t == 0)
                    continue ;
                Up[i][k][j] = k-j+1+t;
          }
        // pentru capatul de sus
        memset(Max[crt], 0, sizeof(Max[crt]));
        for(j = 1; j <= M; j++)
         for(k = j+2; k <= M; k++)
          if(Up[i][j][k] == -1)
            Up[i][j][k] = baga_up(i, j, k);

        prev ^= 1, crt ^= 1;
    }
}

void solve_down(void)
{
    int i, j, k, t;

    prev = 0, crt = 1;
    memset(Max, 0, sizeof(Max));
    
    for(i = N; i >= 1; i--)
    {
        // pentru mijloc
        for(j = 2; j < M; j++)
         for(k = j; k < M; k++)
          if( getsum(i, j, k) == 0 )
          {
                t = max(Down[i+1][j-1][k+1], Down[i+1][k][j]);
                if(t == 0)
                    continue ;
                Down[i][k][j] = k-j+1+t;
          }
        // pentru capatul de jos
        memset(Max[crt], 0, sizeof(Max[crt]));
        for(j = 1; j <= M; j++)
         for(k = j+2; k <= M; k++)
          if(Down[i][j][k] == -1)
            Down[i][j][k] = baga_down(i, j, k);
        prev ^= 1, crt ^= 1;
    }
}

void ruleaza(void)
{
    int i, j, k, t1, t2;

    for(i = 1; i <= N; i++)
     for(j = 1; j <= M; j++)
      for(k = j+2; k <= M; k++)
        Up[i][j][k] = Down[i][j][k] = -1;

    solve_up();
    solve_down();

    for(i = 2; i < N; i++)
     for(j = 2; j < M; j++)
      for(k = j; k < M; k++)
       if( getsum(i, j, k) == 0 )
       {
            t1 = max(Up[i-1][k][j], Up[i-1][j-1][k+1]);
            t2 = max(Down[i+1][k][j], Down[i+1][j-1][k+1]);
            if(t1 > 0 && t2 > 0)
                res = max(res, k-j+1+t1+t2);
       }
}

void read_data(void)
{
    int i, j, k;

    scanf("%d %d\n", &N, &M);

    for(i = 1; i <= N; i++)
     for(j = 1; j <= M; j++)
     {
        scanf("%d ", &k);
        sum[i][j] = sum[i-1][j]+sum[i][j-1]-sum[i-1][j-1]+k;
     }
}

void write_data(void)
{
    printf("%d\n", res);
}

int main(void)
{
    freopen("imax.in", "rt", stdin);
    freopen("imax.out", "wt", stdout);

    read_data();
    ruleaza();
    write_data();

    return 0;
}




            

    


