#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

const char iname[] = "casute.in";
const char oname[] = "casute.out";

#define MAXN   3000
#define Modulo 666013
#define shift(a, b) ((a) ^= (b) ^= (a) ^= (b))

int  N, M;

int  H[MAXN];

vector <int> G[MAXN];

unsigned int  V[MAXN][MAXN / 32 + 5];

int  deg[MAXN];

bool mark[MAXN];

int  Q[MAXN];

int  A[MAXN], B[MAXN];

struct X {
    int i;
    int j;
    int k;
} P[3000 * 2999 / 2 + 10];  int sz;


void read_in(void)
{
    int i;
    int j;
    int x, y;
    
    scanf("%d %d", &N, &M);
    for (i = 0; i < N; ++ i)
        scanf("%d", &H[i]), A[i] = i;
    for (i = 0; i < N; ++ i) {
        for (j = i + 1; j < N; ++ j)
            if (H[i] > H[j])
                shift(H[i], H[j]), shift(A[i], A[j]);
    }
    for (i = 0; i < N; ++ i)
        B[A[i]] = i;

    for (i = 0; i < M; ++ i) {
        scanf("%d %d", &x, &y);
        x --, x = B[x];
        y --, y = B[y];
        deg[x] ++;
        G[y].push_back(x);
    }
    for (i = 0; i < N; ++ i)
        if (deg[i] == 0)    mark[i] = true;
}

int cmp(X a, X b) {
    if (a.i != b.i)     return a.i < b.i;
    return a.j < b.j;
}

inline void copy(const int x, const int y)
{
    const int lim = N / 32 + 5;
    
    for (int i = 0; i < lim; ++ i)
        V[x][i] |= V[y][i];
}

int main(void)
{
    freopen(iname, "r", stdin);
    read_in();

    int head = 0, tail = 0;

    for (int i = 0; i < N; ++ i)
        if (mark[i] == true)      Q[tail ++] = i;

    for (; head < tail; ++ head) {
        int x = Q[head];
        V[x][x >> 5] |= 1 << (x & 31);
        for (int i = (int)(G[x].size() - 1); i >= 0; -- i) {
            int y = G[x][i];
            copy(y, x);
            if ((-- deg[y]) == 0)
                Q[tail ++] = y;
        }
    }

    int rez = 0;

    const int lim = N / 32 + 5;
    
    for (int i = 0; i < N; ++ i) {
        for (int j = i + 1; j < N; ++ j) {
            int ans = -1;
            for (int gr = j >> 5; gr < lim; ++ gr) {
                unsigned int si = V[i][gr] & V[j][gr];
                if (si == 0)  continue ;
                for (unsigned int bit = 0; bit < 32; ++ bit)
                    if ((si >> bit) & 1)  if (gr * 32 + int(bit) >= j) {
                        ans = gr * 32 + int(bit);
                        break ;
                    }
                if (ans != -1)  break ;
            }
            P[sz].i = A[i] + 1;
            P[sz].j = A[j] + 1;
            P[sz].k = (ans != -1) ? A[ans] + 1 : 0;
            if (P[sz].i > P[sz].j)
                shift(P[sz].i, P[sz].j);
            sz ++;
        }
    }

    freopen(oname, "w", stdout);
    
    sort(P, P + sz, cmp);
    for (int i = 0; i < sz; ++ i)
        rez = (rez * (N + 1) + P[i].k) % Modulo;

    printf("%d\n", rez);

    return 0;
}
