#include <stdio.h>
#include <string.h>

#define maxim(a, b) ((a > b) ? a : b)
#define minim(a, b) ((a < b) ? a : b)
#define INF 900000000
#define NMax 155

int N, M, D[NMax][NMax], U[4][NMax][NMax], S[NMax], fst[NMax], bst = 0;
int W[4][NMax][NMax];
int down[NMax], up[NMax];

void matrix_up(void)
{
      int i, j, k, min;

      for (i = 1; i <= M; i++)
      {
          for (j = 1; j <= N; j++)
              if (D[i][j]) up[j] = 0; else up[j]++;

          for (j = 1; j <= N; j++)
          {
              for (k = j, min = INF; k <= N; k++)
              {
                  min = minim(min, up[k]);
                  if (U[0][i][k] < min * (k-j+1))
                     U[0][i][k] = min * (k-j+1), W[0][i][k] = min;
                  if (U[1][i][j] < min * (k-j+1))
                     U[1][i][j] = min * (k-j+1), W[1][i][j] = min;
              }
          }
          
      }
}

void matrix_down(void)
{
     int i, j, k, min;

     for (i = M; i >= 1; i--)
     {
          for (j = 1; j <= N; j++)
              if (D[i][j]) down[j] = 0; else down[j]++;

          for (j = 1; j <= N; j++)
          {
              for (k = j, min = INF; k <= N; k++)
              {
                  min = minim(min, down[k]);
                  if (U[2][i][k] < min * (k-j+1))
                     U[2][i][k] = min * (k-j+1), W[2][i][k] = min;
                  if (U[3][i][j] < min * (k-j+1))
                     U[3][i][j] = min * (k-j+1), W[3][i][j] = min;
              }
          }

     }
     
}

int make_try(int L1, int L2, int C1, int C2)
{
    int H1 = 0, W1 = 0, H2 = 0, W2 = 0;

    W1 = minim(W[0][L1-1][C2], W[1][L1-1][C2+1]);
    if (W1 == 0) return -INF;
    H1 = U[0][L1-1][C2] / W[0][L1-1][C2] + U[1][L1-1][C2+1] / W[1][L1-1][C2+1];

    W2 = minim(W[2][L2+1][C2], W[3][L2+1][C2+1]);
    if (W2 == 0) return -INF;
    H2 = U[2][L2+1][C2] / W[2][L2+1][C2] + U[3][L2+1][C2+1] / W[3][L2+1][C2+1];

   return (L2-L1+1) * (C2-C1+1) + H1 * W1 + H2 * W2;
}

int main(void)
{
    int i, j, C1, C2, L1, L2, AREA;
    
    freopen("imax.in", "r", stdin);
    freopen("imax.out", "w", stdout);

    scanf("%d %d", &M, &N);
    for (i = 1; i <= M; i++)
        for (j = 1; j <= N; j++)
            scanf("%d", &D[i][j]);

    matrix_up();
    matrix_down();

    for (L1 = 1; L1 <= M; L1++)
    {
        memset(S, 0, sizeof(S));
        
        for (L2 = L1; L2 <= M; L2++)
        {
             for (C1 = 1; C1 <= N; C1++) S[C1] += D[L2][C1];
             for (i = N, fst[N+1] = N+1; i >= 1; i--)
                 if (!S[i])
                      fst[i] = fst[i+1];
                 else fst[i] = i;

             for (C1 = 1; C1 <= N; C1++)
             {
                  C2 = fst[C1]-1;

                  if (C1 > C2) continue;

                                    
                  AREA = make_try(L1, L2, C1, C2);                  
                  bst = maxim(bst, AREA);

                  if (C2 > C1)
                  {
                     AREA = make_try(L1, L2, C1, C2-1);
                     bst = maxim(bst, AREA);                     
                  }
                  
             }
        
        }
    }

    printf("%d\n", bst);

    return 0;    
}

