#include <cstdio>
#include <vector>
#include <queue>
#include <algorithm>

using namespace std;

#define PB push_back

const int NMAX = 3072;
const int MOD = 666013;

int N, M, R, rez;
int H[NMAX], Hmax, Cmax, L[NMAX];
bool V[NMAX];
vector <int> G[NMAX], T[NMAX];

void read(void) {
	FILE *fin = fopen("casute.in", "rt");
	int i, u, v;

	fscanf(fin, " %d %d", &N, &M);

	for (i = 1; i <= N; ++i) 
		fscanf(fin, " %d", H + i);
	
	for (i = 0; i < M; ++i) {
		fscanf(fin, " %d %d", &u, &v);

		G[v].PB(u);
		T[u].PB(v);
	}

	fclose(fin);
}

void BFS(int u) {
	int Q[NMAX], end, beg, v;
	vector <int> :: iterator it;

	end = 1; beg = 0; Q[0] = u;

	for (; beg < end; ++beg) {
		v = Q[beg];
		L[v] = u;

//		printf("process %d\n", v);

		for (it = G[v].begin(); it != G[v].end(); ++it)
			if (V[*it] == false) {
				Q[end++] = *it;
//				printf("v -> %d\n", *it);
				V[*it] = true;
			}
	}
}

struct comp {
	bool operator() (const int &a, const int &b) const {
		return H[a] > H[b];
	}
};

void solve(void) {
	int i, j, p = 1, u;
	priority_queue <int, vector<int>, comp> Q;
	vector <int> :: iterator it;

	for (i = N - 1; i; --i) {
		memset(L, 0x00, sizeof(L));
		memset(V, 0x00, sizeof(V));

		V[i] = true;

		for (Q.push(i); !Q.empty(); Q.pop()) {
			u = Q.top();
//			printf("extract %d\n", u);

			BFS(u);

			for (it = T[u].begin(); it != T[u].end(); ++it)
				if (V[*it] == false) {
					Q.push(*it);
//					printf("v -> %d\n", *it);
					V[*it] = true;
				}
		}
		
//		printf("%d\n", i);

		for (j = N; j > i; --j) {
			rez = (rez + p * L[j]) % MOD;
//			printf("%d*%d+", p, L[j]);
//			printf("(%d %d) -> %d\n", i, j, L[j]);
			p = (p * (N + 1)) % MOD;
		}
	}
}

void write(void) {
	FILE *fout = fopen("casute.out", "wt");

	fprintf(fout, "%d\n", rez);

	fclose(fout);
}

int main(void) {

	read();

	solve();

	write();

	return 0;
}

