#include <cstdio>
#include <cstring>


#define MAXN 256
#define MAXK 128
#define MAXL 8
#define BAZA 1000000000
#define OUTPUT_FORMAT "%09d"

int N, K, NR;
int nr[2][MAXK][MAXK][2][MAXL];

inline void set( int A[], int B )
{
	memset( A, 0, sizeof(A) );
	if (B == 0)
		A[0] = 1;
	
	for (; B; B /= BAZA)
		A[ ++A[0] ] = B % BAZA;
}

inline void add( int A[], int B[] )
{
	int i, t = 0;
	for (i = 1; i <= A[0] || i <= B[0] || t; i++, t /= BAZA)
		A[i] = (t += A[i] + B[i]) % BAZA;
	A[0] = i - 1;
}

inline void print( int A[] )
{
	printf("%d", A[A[0]]);
	for (int i = A[0] - 1; i > 0; i--)
		printf(OUTPUT_FORMAT, A[i]);
	printf("\n");
}

int main()
{
	freopen("culmi.in", "rt", stdin);
	freopen("culmi.out", "wt", stdout);

	scanf("%d %d", &N, &K);
	N *= 2;
	set( nr[0][0][0][0], 1 );
	
	int step = 1;
	for (int i = 1; i <= N; i++, step ^= 1)
	{
		memset( nr[step], 0, sizeof(nr[step]) );
		for (int j = 0; j <= i && j <= N / 2; j++)
			for (int k = 0; k <= K; k++)
			{
				if (j >= 1)
				{
					add( nr[step][j][k][0], nr[1 ^ step][j - 1][k][0] );
					add( nr[step][j][k][0], nr[1 ^ step][j - 1][k][1] );
				}
				
				if (j + 1 <= N / 2)
				{
					add( nr[step][j][k][1], nr[1 ^ step][j + 1][k][1] );
					add( nr[step][j][k][1], nr[1 ^ step][j + 1][k - 1][0] );
				}
			}
	}

	print( nr[1 ^ step][0][K][1] );
	
	return 0;
}
