#include <stdio.h>
#include <memory.h>

const char iname[] = "culmi.in";
const char oname[] = "culmi.out";

#define MAXC 7

#define base 100000000000000000

typedef unsigned long long u64;


u64 cnt[2][201][101][2][MAXC];


void add(u64 A[], u64 B[])
{
    int i;
    u64 tr = 0;
    for (i = 1; i <= A[0] || i <= B[0] || tr > 0; ++ i, tr /= base) {
        if (i > A[0])
            A[i] = 0;
        if (i > B[0])
            B[i] = 0;
        A[i] = (tr += A[i] + B[i]) % base;
    }
    A[0] = i - 1;
}

void print(u64 A[])
{
    printf("%lld", A[A[0]]);
    for (int i = A[0] - 1; i > 0; -- i)
        printf("%17lld", A[i]);
    printf("\n");
}

int main(void)
{
    FILE *fi = fopen(iname, "r");

    int N;
    int K;

    fscanf(fi, "%d %d", &N, &K);

    int stp = 1;

    cnt[1][1][0][1][0] = cnt[1][1][0][1][1] = 1;

    int lim;
    
    for (int i = 2; i <= 2 * N; ++ i) {
        stp = i & 1;
        lim = (i < N) ? i : N;
        for (int j = 1; j <= lim; ++ j) {
            for (int k = 0; k <= K; ++ k) {  // 1 +, 0 -
                cnt[stp][j][k][1][0] = 0;
                cnt[stp][j][k][0][0] = 0;
                add(cnt[stp][j][k][1], cnt[stp ^ 1][j - 1][k][1]);
                add(cnt[stp][j][k][1], cnt[stp ^ 1][j][k][0]);
                add(cnt[stp][j][k][0], cnt[stp ^ 1][j + 1][k][0]);
                add(cnt[stp][j][k][0], cnt[stp ^ 1][j][k - 1][1]);
            }
        }
    }
    freopen(oname, "w", stdout);
    print(cnt[0][1][K][0]);

    fcloseall();
    return 0;
}
