/* Solutie cu O(lgN) pe mutare */ 
#include <stdio.h>

#define MAX_N 100005
#define MAX_T 262144

int N, M, A[MAX_N], T[MAX_T];
long long sum;

void build_tree(int n, int l, int r)
{
    int m = (l+r)>>1;

    if (l == r) { T[n] = A[l]; return; }
    build_tree(n<<1, l, m);
    build_tree((n<<1)|1, m+1, r);
    T[n] = T[n<<1] ^ T[(n<<1)|1];
}

void update(int n, int l, int r, int x)
{
    int m = (l+r)>>1;

    if (l == r) { T[n] = A[l]; return; }
    if (x <= m)
        update(n<<1, l, m, x);
    else
        update((n<<1)|1, m+1, r, x);
    T[n] = T[n<<1] ^ T[(n<<1)|1];
}

int query(int n, int l, int r, int x)
{
    int m = (l+r)>>1;

    if (l == r) return l;
    if (T[n<<1] & x)
        return query(n<<1, l, m, x);
    return query((n<<1)|1, m+1, r, x);
}

int main(void)
{
    int i, j, l, r;

    scanf("%d %d", &N, &M);
    for (i = 1; i <= N; i++)
    {
        scanf("%d %d", &l, &r);
        A[i] = r-l-1; sum += A[i];
    }

    build_tree(1, 1, N);
    while (sum)
    {
        for (i = 30; i >= 0; i--)
            if (T[1]&(1<<i)) break;
        i = query(1, 1, N, 1<<i);
        j = A[i]-(T[1]^A[i]);
        printf("%d %d\n", i, j);
        fflush(stdout);
        A[i] -= j; sum -= j;
        update(1, 1, N, i);
        if (!sum) break;

        scanf("%d %d", &i, &j);
        A[i] -= j; sum -= j;
        update(1, 1, N, i);
    }

    return 0;
}
