#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
using namespace std;

#define NMAX 10005

int K, x, l, r, m, i, j, stp, nr, stk, lst[NMAX], st[NMAX], pi[NMAX], u[NMAX];
map<pair<int, int>, int> S;
vector<int> adj[NMAX];

void dfs(int x)
{
    u[x] = 1;
    for (vector<int> :: iterator it = adj[x].begin(); it != adj[x].end(); it ++)
        if (!u[*it])
        {
            pi[*it] = x;
            dfs(*it);
        }
}

int get_dist(int x, int y)
{
	if (x > y) swap(x, y);
	if (S.find(make_pair(x, y)) != S.end()) return S[make_pair(x, y)];
	int r;
    
	printf("ASK %d %d\n", x, y);
    fflush(stdout);
    
	scanf("%d", &r);
	S[make_pair(x, y)] = r;
	return r;
}

void insert(int p, int sz, int x)
{
    int i;
    for (i = sz; i >= p; i --) lst[i+1] = lst[i];
    lst[p] = x;
}

inline void add_edge(int x, int y)
{
    adj[x].push_back(y), adj[y].push_back(x);
}

int main(void)
{
	scanf("%d", &K);
	nr = 3, lst[1] = 1, lst[2] = 2, lst[3] = 3;
	for (stp = 4; stp <= K; stp ++)
	{
		l = 1, r = nr;
		do
		{
			m = (l+r) / 2;
            if (get_dist(lst[l], stp)+get_dist(stp, lst[m])-get_dist(lst[l], lst[m]) <=
                get_dist(lst[m], stp)+get_dist(stp, lst[r])-get_dist(lst[m], lst[r]))
                r = m;
            else
                l = m;
		} while(r-l > 1);
        insert(r, stp-1, stp);
	}

/*
    fprintf(stderr, "ordinea frunzelor:\n");
    for (i = 1; i <= K; i ++)
        fprintf(stderr, "%d ", lst[i]);
    fprintf(stderr, "\n");
*/

    nr = K;
    st[stk = 1] = lst[1];
    for (i = 1; i < get_dist(lst[1], lst[2]); i ++)
    {
        st[++stk] = ++nr;
        add_edge(st[stk], st[stk-1]);
    }
    st[++stk] = lst[2];
    add_edge(st[stk], st[stk-1]);

    for (stp = 3; stp <= K; stp ++)
    {
        //rezolvam lst[stp]
        int d1, d2, t, x = lst[stp], ln;
        d1 = get_dist(st[1], x);
        d2 = get_dist(x, st[stk]);
        t = get_dist(st[1], st[stk]);

        if ((d1+d2-t)&1) { fprintf(stderr, "parity error\n"); exit(0); }
        ln = (d1+d2-t)/2;

        for (i = 1; i <= d2-ln; i ++) --stk;
        for (i = 1; i < ln; i ++)
        {
            st[++stk] = ++nr;
            add_edge(st[stk], st[stk-1]);
        }
        st[++stk] = x;
        add_edge(st[stk], st[stk-1]);
    }


    printf("DONE %d", nr);
    memset(u, 0, sizeof(u));
    pi[1] = 0;
    dfs(1);
    for (i = 1; i <= nr; i ++)
        printf(" %d", pi[i]);
    printf("\n");
    fflush(stdout);
    
	return 0;
}
